<template>
  <div class="app-container">
    <crud-table
      @getList="fetchCollection"
      @go="go"
      @remove="remove"
      :resourceName="resourceName"
      :rows="collection.data"
      :columns="columns"
      :loading="loading"
    >
      <el-row :gutter="20" slot="filters" class="filters">
        <el-col :span="12">
        <el-input
          v-model="filters.name.$search"
          @input="debouncedFetchCollection"
          placeholder="Nombre"
          clearable />
        </el-col>
        <el-col :span="12">
          <el-select
            @input="debouncedFetchCollection"
            v-model="filters.category.$in"
            placeholder="Categorías" multiple collapse-tags>
            <el-option
              v-for="(category, idx) in clientCategories"
              :key="idx"
              :label="category"
              :value="category">
            </el-option>
          </el-select>
        </el-col>
      </el-row>
    </crud-table>
    <el-pagination
      background
      @current-change="paginate"
      layout="prev, pager, next"
      :page-size="collection.limit"
      :total="collection.total">
    </el-pagination>
  </div>
</template>

<script>
import api from "@/feathers";
import CrudTable from "@/common/crud-table.component";
import CrudTableMixin from "@/common/crud-table.mixin";
import { debounce } from "lodash";
import { filterQuery } from "@/common/query";

export default {
  name: "clients-list",
  mixins: [CrudTableMixin],
  components: {
    CrudTable
  },
  data() {
    return {
      resourceName: {
        singular: "Client",
        plural: "Clients"
      },
      collection: {
        data: [],
        total: 0
      },
      columns: [
        { prop: "code", label: "ID", minWidth: 30 },
        { prop: "name", label: "Nombre", minWidth: 160 },
        { prop: "category", label: "Categoría", minWidth: 80 }
      ],
      filters: {
        name: { $search: "" },
        category: { $in: [] },
        $limit: 10,
        $skip: 0
      },
      clientCategories: [],
      loading: false
    };
  },
  async created() {
    this.routePrefix = "clients";
    this.service = api.service("clients");
    await this.getCategories();
    await this.fetchCollection();
  },
  computed: {
    query() {
      return filterQuery({}, this.filters);
    }
  },
  methods: {
    async debouncedFetchCollection() {
      return debounce(this.fetchCollection, 500)();
    },
    async fetchCollection() {
      this.loading = true;
      const response = await this.service.find({
        query: this.query
      });
      this.collection = response;
      this.loading = false;
    },
    async getCategories() {
      this.loading = true;
      this.clientCategories = await api.service("client-categories").find();
      this.loading = false;
    }
  }
};
</script>
